Add coverage for the previous patch. Although most plugins don't
change can_fua or can_fast_zero on the fly, the code should still
not abort when calling .zero with a flag that was permitted by
the previous open but not permitted by the current open.
Signed-off-by: Eric Blake <eblake(a)redhat.com>
---
tests/Makefile.am | 2 +
tests/test-retry-zero-flags.sh | 126 +++++++++++++++++++++++++++++++++
2 files changed, 128 insertions(+)
create mode 100755 tests/test-retry-zero-flags.sh
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 60cba6c5..9d95d567 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -123,6 +123,7 @@ EXTRA_DIST = \
test-retry-extents.sh \
test-retry-readonly.sh \
test-retry-reopen-fail.sh \
+ test-retry-zero-flags.sh \
test-shutdown.sh \
test-ssh.sh \
test.tcl \
@@ -1062,6 +1063,7 @@ TESTS += \
test-retry-readonly.sh \
test-retry-extents.sh \
test-retry-reopen-fail.sh \
+ test-retry-zero-flags.sh \
$(NULL)
# truncate filter tests.
diff --git a/tests/test-retry-zero-flags.sh b/tests/test-retry-zero-flags.sh
new file mode 100755
index 00000000..df2ea0c3
--- /dev/null
+++ b/tests/test-retry-zero-flags.sh
@@ -0,0 +1,126 @@
+#!/usr/bin/env bash
+# nbdkit
+# Copyright (C) 2018-2019 Red Hat Inc.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# * Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# * Neither the name of Red Hat nor the names of its contributors may be
+# used to endorse or promote products derived from this software without
+# specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+source ./functions.sh
+set -e
+set -x
+
+requires nbdsh -c 'i = nbd.CMD_FLAG_FAST_ZERO
+exit(not h.supports_uri())'
+
+files="retry-zero-flags-count retry-zero-flags-open-count"
+rm -f $files
+cleanup_fn rm -f $files
+
+touch retry-zero-flags-count retry-zero-flags-open-count
+start_t=$SECONDS
+
+# Create a custom plugin which will test retrying.
+nbdkit -v -U - \
+ sh - \
+ --filter=retry retry-delay=1 \
+ --run 'nbdsh --uri $uri -c "
+h.zero (512, 0)
+try:
+ h.zero (512, 0,
+ nbd.CMD_FLAG_FUA | nbd.CMD_FLAG_NO_HOLE | nbd.CMD_FLAG_FAST_ZERO)
+except nbd.Error as ex:
+ assert ex.errno == \"ENOTSUP\"
+h.zero (512, 0, nbd.CMD_FLAG_FUA)
+ "' <<'EOF'
+#!/usr/bin/env bash
+case "$1" in
+ open)
+ # Count how many times the connection is (re-)opened.
+ read i < retry-zero-flags-open-count
+ echo $((i+1)) > retry-zero-flags-open-count
+ ;;
+ can_write | can_zero) exit 0 ;;
+ can_fua)
+ read i < retry-zero-flags-open-count
+ case $i in
+ 1 | 4 | 5) echo native ;;
+ *) echo none ;;
+ esac
+ ;;
+ can_fast_zero)
+ read i < retry-zero-flags-open-count
+ case $i in
+ 1 | 2 | 5) exit 0 ;;
+ *) exit 3 ;;
+ esac
+ ;;
+ zero)
+ # First zero fails, thereafter it works
+ read i < retry-zero-flags-count
+ ((i++))
+ echo $i > retry-zero-flags-count
+ if [ $i -le 1 ]; then
+ echo "EIO zero failed" >&2
+ exit 1
+ fi
+ ;;
+
+ get_size) echo 512 ;;
+ *) exit 2 ;;
+esac
+EOF
+
+# In this test we should see the following pattern:
+# both fua and fast_zero supported
+# first zero FAILS
+# retry and wait 1 seconds
+# only fast_zero supported
+# first zero succeeds
+# second zero FAILS due to missing fua support
+# retry and wait 1 seconds
+# neither fua nor fast_zero supported
+# second zero FAILS fast due to missing fast_zero support
+# third zero FAILS due to missing fua support
+# retry and wait 1 seconds
+# only fua supported
+# third zero succeeds
+
+# The minimum time for the test should be 1+1+1 = 3 seconds.
+end_t=$SECONDS
+if [ $((end_t - start_t)) -lt 3 ]; then
+ echo "$0: test ran too quickly"
+ exit 1
+fi
+
+# Check the handle was opened 4 times (first open + one reopen for
+# each retry).
+read open_count < retry-zero-flags-open-count
+if [ $open_count -ne 4 ]; then
+ echo "$0: open-count ($open_count) != 4"
+ exit 1
+fi
--
2.21.0